c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine Adapt_MPI_ini

      !integer status(MPI_STATUS_SIZE)   
      
      include 'common.2D'


      integer nFP_difference_global(n_procs_max),nFP_global(n_procs_max)
      real  xrank_difference_global(n_procs_max)
      real  xmin_rank_global(n_procs_max)
      real  zrank_difference_global(n_procs_max)
      real  zmin_rank_global(n_procs_max)
c
c
c
      character name*40,FMTtemp*9,FMTtemp2*6
      CHARACTER(LEN=5000) :: FMTnprocs  !Be careful of this if you use many processors

      if(rank_id.eq.0)then
        name = 'MPI_Partition_init.txt'
        open(470,file=name,STATUS='replace')
      endif

      !- Construct Format editor for file MPI_Partition_init.txt'
      !- Make sure Length above is large enough!! (i.e. change 1000 appropriately)
      FMTtemp  = ',1x,e12.6'
      FMTtemp2 = ',1x,i6'

      !- Check length of character FMTnprocs -
      if(5+n_procs*(len(FMTtemp)+len(FMTtemp2)+len(FMTtemp))
     &  .gt.len(FMTnprocs))then
        if(rank_id.eq.0)then
          print*
          print*,'ERROR in Adapt_ini_MPI_2D.f'
          print*,'length of FMTnprocs exceeds defined length'
          print*,'rank_id  ',rank_id
          print*,'len(FMTnprocs) ',len(FMTnprocs)
          print*,
     &    '5+n_procs*(len(FMTtemp)+len(FMTtemp2)+len(FMTtemp))',
     &     5+n_procs*(len(FMTtemp)+len(FMTtemp2)+len(FMTtemp))
          print*
        endif
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif

      write(FMTnprocs,*)'(i5',(FMTtemp, i_fmt=1,n_procs),
     &                        (FMTtemp2,j_fmt=1,n_procs),
     &                        (FMTtemp ,k_fmt=1,n_procs),')'

      xmin_rank_ini = xmin_rank
      xmax_rank_ini = xmax_rank
c     ymin_rank_ini = ymin_rank
c     ymax_rank_ini = ymax_rank
      zmin_rank_ini = zmin_rank
      zmax_rank_ini = zmax_rank
      np_local_ini  = np_local
      nFP_local_ini = nFP_local

      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point

      !- Optimise MPI Partitions once at beginning of simulation -
        nFP_difference_local = abs(nFP_local - nFP_local_East)
        nFP_local_previous = nFP_local
        nFP_difference_max_temp = nFP_difference_max  !Store input value for later
        !- Ideal Target value for particles pre processor -
        nFP_Target = np/n_procs
        nFP_difference_max = int(0.05*np/n_procs)   !max particle difference is 5% of ideal value
        nFP_difference_maxVal = nFP_difference_max + 1
c        print*,'in ADAPT_ini, rank_id ',rank_id
c     &      ,', np_local = ',np_local
c     &      ,nFP_local, nFP_local_East,nFP_difference_local
        n_shifts = 0
        nFP_difference_maxVal_previous  = np
        nFP_difference_maxVal_previous2 = np
        xrank_difference_minVal = 8.0*h
        xrank_difference_local = xmax_rank-xmin_rank
        i_East_Boundary_Change_old = 0
        n_shifts_max = n_ini_Adapt

        if(rank_id.eq.0)then
          print*,'Shifting MPI Partitions, n_shifts_max ',n_shifts_max
        endif

        do while(
     &     (nFP_difference_maxVal.gt.4*nFP_difference_max.and.
     &      xrank_difference_minVal.gt.xrank_length_max)
     &      .or.n_shifts.lt.n_shifts_max)

c        do ii=1,20   !For debugging purposes only
          n_shifts = n_shifts + 1
          nFP_difference_global = 0
          nFP_difference_maxVal    = 0
          nFP_local = np_local - nb_local*mod(iBC,2)        
          nFP_local_temp = nFP_local  

          !print*,'Calling index_check, n_shifts = ',n_shifts
  
          if(n_procs_x.gt.1)call index_check_EastWest    !<---  Adapt_Check & Adapt_Regrid are called from within this subroutine
          if(i_call_UpDown    .eq.1)call index_check_UpDown      !<---  Adapt_Check & Adapt_Regrid are called from within this subroutine
c         if(i_call_NorthSouth.eq.1)call index_check_NorthSouth  !<---  Adapt_Check & Adapt_Regrid are called from within this subroutine
          !stop

          nFP_difference_local  = 0
          nFP_difference_local_1= 0
          nFP_difference_local_2= 0
          nFP_difference_local_3= 0
          if(n_procs_x.gt.1)then
            nFP_difference_local_1= abs(nFP_local - nFP_local_East)
          endif
c          if(n_procs_y.gt.1)then
c            nFP_difference_local_2= abs(nFP_local - nFP_local_North)
c          endif
          if(n_procs_z.gt.1)then
            nFP_difference_local_3= abs(nFP_local - nFP_local_Above)
          endif
          nFP_difference_local = min(nFP_difference_local_1,
     &                               nFP_difference_local_3)

          if(rank_idx.eq.n_procs_x-1.and.
     &       (.NOT.iCartTop_periodicity(1)))then
            nFP_difference_local= 0
          endif
c         if(rank_idy.eq.n_procs_y-1.and.
c    &       (.NOT.iCartTop_periodicity(2)))then
c           nFP_difference_local= 0
c         endif
          if(rank_idz.eq.n_procs_z-1.and.
     &       (.NOT.iCartTop_periodicity(3)))then
            nFP_difference_local= 0
          endif
          !- load Fluid particle number & differences from each proc into global matrix -
          call MPI_GATHER(
     &        nFP_difference_local            , 1, MPI_INTEGER,
     &        nFP_difference_global(rank_id+1), 1, MPI_INTEGER,
     &        0, grid_comm, ierr)
          call MPI_GATHER(
     &        nFP_local            , 1, MPI_INTEGER,
     &        nFP_global(rank_id+1), 1, MPI_INTEGER,
     &        0, grid_comm, ierr)

          xrank_difference_local = xmax_rank - xmin_rank
c         yrank_difference_local = ymax_rank - ymin_rank
          zrank_difference_local = zmax_rank - zmin_rank

          call MPI_GATHER(
     &        xrank_difference_local            , 1, MPI_REAL,
     &        xrank_difference_global(rank_id+1), 1, MPI_REAL,
     &        0, grid_comm, ierr)
          call MPI_GATHER(
     &        xmin_rank                  , 1, MPI_REAL,
     &        xmin_rank_global(rank_id+1), 1, MPI_REAL,
     &        0, grid_comm, ierr)

          call MPI_GATHER(
     &        zrank_difference_local            , 1, MPI_REAL,
     &        zrank_difference_global(rank_id+1), 1, MPI_REAL,
     &        0, grid_comm, ierr)
          call MPI_GATHER(
     &        zmin_rank                  , 1, MPI_REAL,
     &        zmin_rank_global(rank_id+1), 1, MPI_REAL,
     &        0, grid_comm, ierr)

          do i_rank=0,n_procs-1
           !if(i_rank.eq.rank_id.and.n_shifts.ge.0)then   !Use this line to print out shift information
           if(i_rank.eq.rank_id.and.n_shifts.ge.n_shifts_max)then  !Use this line when using the code generally
              write(*,475)
     &               'rank_id ',i_rank,' n_shifts ',n_shifts,
     &                nFP_difference_local,nFP_local,
     &                i_West_Boundary_Change, i_East_Boundary_Change,
     &                xmin_rank, xrank_difference_local
              call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
            endif
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          enddo

          if(rank_id.eq.0)then
            write(470,FMTnprocs)   !write(470,474)
     &                n_shifts,  
     &                (xmin_rank_global(i_rank),i_rank=1,n_procs) ,
     &                (nFP_global(j_rank),j_rank=1,n_procs),
     &                (xrank_difference_global(k_rank),k_rank=1,n_procs)
                
          endif

          nFP_local_previous3 = nFP_local_previous2
          nFP_local_previous2 = nFP_local_previous1
          nFP_local_previous1 = nFP_local_temp

          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          !if(rank_id.eq.0)print*

          if(rank_id.eq.0)then
            nFP_difference_maxVal = maxval(nFP_difference_global)
            !xrank_difference_minVal = minval(xrank_difference_global)
            xrank_difference_minVal = 100.0*h
            do i_rank=1,n_procs
              if(xrank_difference_global(i_rank)
     &                 .lt.xrank_difference_minVal)then
                xrank_difference_minVal=xrank_difference_global(i_rank)
              endif
            enddo
            if(n_shifts/20*20.eq.n_shifts)then
               print*,'Shifting MPI Partitions, n_shifts ',n_shifts
            endif
c            print*,'nFP_difference_global, n_shifts ',n_shifts
c            print*,'nFP_difference_maxVal & max ',
c     &              nFP_difference_maxVal,nFP_difference_max
c            print*,'xrank_difference_minVal & xrank_length_max ',
c     &              xrank_difference_minVal,  xrank_length_max
c            do i_rank=0,n_procs-1
c              print*,'rank_id ',i_rank,nFP_difference_global(i_rank+1),
c     &                nFP_global(i_rank+1)
c            enddo

          endif

          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          call MPI_BCast(nFP_difference_maxVal  , 1, MPI_INTEGER, 
     &                   0, MPI_COMM_WORLD, ierr)
          call MPI_BCast(xrank_difference_minVal, 1, MPI_REAL, 
     &                   0, MPI_COMM_WORLD, ierr)
          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c          print*,
c     &    'rank_id, nFP_difference_maxVal, xrank_difference_minVal ',
c     &     rank_id, nFP_difference_maxVal, xrank_difference_minVal
          if(n_shifts.lt.20)then
            nFP_difference_maxVal_previous2=
     &      nFP_difference_maxVal_previous
            nFP_difference_maxVal_previous =nFP_difference_maxVal
          endif

          !-- Avoid infinite looping --
          if(n_shifts.eq.n_shifts_max)then
            nFP_difference_maxVal = 0
          endif
        enddo

        !- return nFP_difference_max to input value -
        nFP_difference_max = nFP_difference_max_temp

        if(iBC.eq.1)then
          call updateNormals_2D(1,nb_local,i_dummy) 
        endif  

        
        if(rank_id.eq.0)close(470)
        
        if(rank_id.eq.0)then
          print*
          print*,'- Final X-Rank positions -'
          write(*,473)'rank_id, '
     &         //' xmin_rank_ini, xmin_rank,'
     &         //' xmax_rank_ini, xmax_rank,'
     &         //' np_local_ini , np_local,'
     &         //' nFP_local_ini, nFP_local'
        endif
          do i=0,n_procs -1
            if(i.eq.rank_id)then
              write(*,474)rank_id, 
     &                    xmin_rank_ini, xmin_rank, 
     &                    xmax_rank_ini, xmax_rank, 
     &                    np_local_ini , np_local,
     &                    nFP_local_ini, nFP_local
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do

        if(rank_id.eq.0)then
          print*
          print*,'- Final Z-Rank positions -'
          write(*,473)'rank_id, '
     &         //' zmin_rank_ini, zmin_rank,'
     &         //' zmax_rank_ini, zmax_rank,'
     &         //' np_local_ini , np_local,'
     &         //' nFP_local_ini, nFP_local'
        endif
          do i=0,n_procs -1
            if(i.eq.rank_id)then
              write(*,474)rank_id, 
     &                    zmin_rank_ini, zmin_rank, 
     &                    zmax_rank_ini, zmax_rank, 
     &                    np_local_ini , np_local,
     &                    nFP_local_ini, nFP_local
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do

        
473   format(a115)
474   format(i5,' ',4(' ',f12.6),' ',4(' ',i6))
475   format(a8,' ',i3,a10,i5,' ',2(' ',i6),'  ',2(' ',i2),2(' ',f12.6))

      return
      end