c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
      
      subroutine SendRecv_Data_toWest

      include 'common.2D'

      integer iabsolute_BP_going_West(nGuestmax)
      integer iabsolute_BP_from_East(nGuestmax)
      
      !-- Derived DataTypes --
      real(kind=kind_XZ)  P_xyz_data_going_West(nGuestmax,2)
      real(kind=kind_XZ)  P_xyz_data_from_East(nGuestmax,2)
      real P_data_going_West(nGuestmax,15)
      real P_data_from_East(nGuestmax,15)
      real BP_data_going_West(nGuestmax,6)
      real BP_data_from_East(nGuestmax,6)
      real Tau_data_going_West(nGuestmax,3)
      real Tau_data_from_East(nGuestmax,3)
c      integer BP_DataType, P_DataType, Tau_DataType, deltaptb_DType
c
      
      itime_check = 10e8   !0   !10e8
      irank_check = 0


      !SendRecv numbers of Guest Particles Between Host Processors

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then 
!         if(rank_id.eq.0.and.itime.ge.0)then   !if(rank_id.eq.-10)then
!           print*
!           print*,'In SendRecv_Data'
!           !print*,'Particles to be exported'
!         end if
!         if(rank_id.eq.irank_check)then   !if(rank_id.eq.-10)then
!           nb_going_Below0 = nb_going_Below
!           np_going_Below0 = np_going_Below
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id-1.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             print*
!             print*,'rank_id ', rank_id
!             print*,'itime   ', itime
!             print*,'nb_local       ',nb_local
!             print*,'np_local       ',np_local
!             print*,'nbf_in_lx_2    ',nbf_in_lx_2
!             print*,'nbfreem_in_lx_2  ',nbfreem_in_lx_2
!             print*,'nb_in_lx_2     ',nb_in_lx_2
!             print*,'nFP_in_lx_2    ',nFP_in_lx_2
!             print*,'np_in_lx_2     ',np_in_lx_2
!             print*,'nbf_in_lx_ncx_localminus1 ',
!      &              nbf_in_lx_ncx_localminus1
!             print*,'nbfreem_in_lx_ncx_localminus1  ',
!      &              nbfreem_in_lx_ncx_localminus1
!             print*,'nb_in_lx_ncx_localminus1   ',
!      &              nb_in_lx_ncx_localminus1
!             print*,'nFP_in_lx_ncx_localminus1  ',
!      &              nFP_in_lx_ncx_localminus1
!             print*,'np_in_lx_ncx_localminus1   ',
!      &              np_in_lx_ncx_localminus1
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       endif

      !-- Zero non-communicating processes --
      if(rank_idx.eq.0
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nbf_from_West = 0
        nbfm_from_West = 0
        nbfreem_from_West = 0
        np_from_West = 0
        if(n_procs_x.eq.1)then
          nbf_from_East = 0
          nbfm_from_East = 0
          nbfreem_from_East = 0
          np_from_East = 0
        end if
      else if(rank_idx.eq.n_procs_x-1
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nbf_from_East = 0
        nbfm_from_East = 0
        nbfreem_from_East = 0
        np_from_East = 0
        if(n_procs_x.eq.1)then
          nbf_from_West = 0
          nbfm_from_West = 0
          nbfreem_from_West = 0
          np_from_West = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.-10)then
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, east, west ',rank_id, east, west 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
            
      !--- East-West Communications ---
        nbf_from_West        = 0  
        nbfm_from_West       = 0  
        nbfreem_from_West    = 0  
        np_from_West         = 0 
      !Send to West Neighbour
        call MPI_SENDRECV(
     &    nbf_in_lx_2  , 1, MPI_INTEGER, west, 104,
     &    nbf_from_East, 1, MPI_INTEGER, east, 104,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    nbfm_in_lx_2   , 1, MPI_INTEGER, west, 106,
     &    nbfm_from_East , 1, MPI_INTEGER, east, 106,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    nbfreem_in_lx_2   , 1, MPI_INTEGER, west, 106,
     &    nbfreem_from_East , 1, MPI_INTEGER, east, 106,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    np_in_lx_2    , 1, MPI_INTEGER, west, 107,
     &    np_from_East  , 1, MPI_INTEGER, east, 107,
     &    grid_comm, status, ierr)
      
          
      !- Zero additional counter for travelling guest particles (from East to Down) -          
      if(ndim.gt.1)then
        nbf_in_lz_2_temp = 0
        nbfm_in_lz_2_temp = 0
        nbfreem_in_lz_2_temp = 0
      endif      

      !With no Open Boundary Water Particles (OBWPs)
      nb_from_East = nbfreem_from_East
      nb_from_West = nbfreem_from_West
          
      !-- Set Particle Numbers of Image on each Processor --    
      nbf_image_local  = nbf_local   + nbf_from_East   + nbf_from_West
      nbfm_image_local = nbfm_local
     &                      + nbfm_from_East + nbfm_from_West
      nbfreem_image_local= nbfreem_local
     &                      + nbfreem_from_East + nbfreem_from_West
      nb_image_local   = nb_local + nb_from_East + nb_from_West
      np_image_local   = np_local + np_from_East + np_from_West     
       
      nbp1_image_local = nb_image_local + 1
      
      !Error catching
      if(np_from_East.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_from_East.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_East ',np_from_East
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      else if(np_from_West.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_from_West.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_West ',np_from_West
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      end if
      if(np_image_local.gt.npar)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'np_image_local.gt.npar'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_image_local ',np_image_local
        print*,'npar           ',npar
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
      if(nbfreem_image_local.ne.nb_image_local)then
        print*
        print*,'ERROR in SendRecv_Data_toWest.f'
        print*,'nbfreem_image_local.ne.nb_image_local'
        print*,'rank_id, itime ',rank_id, itime
        print*,'nbfreem_image_local ',nbfreem_image_local
        print*,'nb_image_local    ',nb_image_local
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
            
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !-- Printout Check for numbers of Particles being passed --
      if(1.eq.2)then
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id, nbf_in_lx_2, nbf_from_East, nbf_from_West '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nbf_in_lx_2, nbf_from_East, nbf_from_West
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &    'rank_id, nbfreem_in_lx_2,nbfreem_from_East,nbfreem_from_West'
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &      rank_id, nbfreem_in_lx_2,nbfreem_from_East,nbfreem_from_West
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id, nb_in_lx_2, nb_from_East, nb_from_West '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nb_in_lx_2, nb_from_East, nb_from_West
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id,  np_in_lx_2, np_from_East, np_from_West '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, np_in_lx_2, np_from_East, np_from_West
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
      
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id,  nbf_image,  nbfreem_image,  nb_image, np_image '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nbf_image_local, nbfreem_image_local, 
     &                 nb_image_local  , np_image_local
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
      end if    !End of:  if(1.eq.2)then
498   format(5('  ',I5,'    '))     
      !--------------------------

      !Synchronize ip_index pointer array for resident particles
      nb_image_temp  =  nb_local
      nFP_image_temp = np_local - nb_local
            
      nbf_image_temp         =  nbf_local
      nbfm_image_temp        =  nbfm_local - nbf_local
      nbfreem_image_temp     =  nbfreem_local - nbfm_local
      
      
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      
      !-- Pack Particle data to be sent West--
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!       if(itime.ge.itime_check.and.rank_id.eq.1)then
!         print*
!         print*,'Packing Particle Data to go West'
!         print*,'rank_id, np_in_lx_2, nb_going_West, np_going_West ',
!      &          rank_id, np_in_lx_2, nb_going_West, np_going_West
!       end if
      nbfm_start    = nbf_in_lx_2 + 1
      nbfreem_start = nbfm_in_lx_2 + 1
      nFP_start     = nb_going_West + 1
      do ii=1,np_going_West     !do ii=1,np_in_lx_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_West_1(ii)
!           if(i_particleType(i).ne.1)then
!             print*
!             print*,'ERROR in SendRecv_Data_toWest'
!             print*,'i_particleType(i).ne.1'
!             print*,'ii, i, i_particleType(i) ',ii, i, i_particleType(i)
!             print*,'xp(i), zp(i) ',xp(i), zp(i)
!             print*,'nbf_in_lx_2     ',nbf_in_lx_2
!             print*,'nbfm_in_lx_2    ',nbfm_in_lx_2
!             print*,'nbfreem_in_lx_2 ',nbfreem_in_lx_2
!             print*,'nbf0_in_lx_2     ',nbf0_in_lx_2
!             print*,'nbfm0_in_lx_2    ',nbfm0_in_lx_2
!             print*,'nbfreem0_in_lx_2 ',nbfreem0_in_lx_2
!             print*,'nb_going_West    ',nb_going_West
!             print*,'np_going_West    ',np_going_West
!             stop
!           endif
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_West_2(ii-nbf0_in_lx_2)
!           if(i_particleType(i).ne.2)then
!             print*
!             print*,'ERROR in SendRecv_Data_toWest'
!             print*,'i_particleType(i).ne.2'
!             print*,'ii, i, i_particleType(i) ',ii, i, i_particleType(i)
!             print*,'xp(i), zp(i) ',xp(i), zp(i)
!             print*,'nbf_in_lx_2     ',nbf_in_lx_2
!             print*,'nbfm_in_lx_2    ',nbfm_in_lx_2
!             print*,'nbfreem_in_lx_2 ',nbfreem_in_lx_2
!             print*,'nbf0_in_lx_2     ',nbf0_in_lx_2
!             print*,'nbfm0_in_lx_2    ',nbfm0_in_lx_2
!             print*,'nbfreem0_in_lx_2 ',nbfreem0_in_lx_2
!             print*,'nb_going_West    ',nb_going_West
!             print*,'np_going_West    ',np_going_West
!             stop
!           endif
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_West_3(ii-(nbf0_in_lx_2+nbfm0_in_lx_2))
!           if(i_particleType(i).ne.3)then
!             print*
!             print*,'ERROR in SendRecv_Data_toWest'
!             print*,'i_particleType(i).ne.3'
!             print*,'ii, i, i_particleType(i) ',ii, i, i_particleType(i)
!             print*,'xp(i), zp(i) ',xp(i), zp(i)
!             print*,'nbf_in_lx_2     ',nbf_in_lx_2
!             print*,'nbfm_in_lx_2    ',nbfm_in_lx_2
!             print*,'nbfreem_in_lx_2 ',nbfreem_in_lx_2
!             print*,'nbf0_in_lx_2     ',nbf0_in_lx_2
!             print*,'nbfm0_in_lx_2    ',nbfm0_in_lx_2
!             print*,'nbfreem0_in_lx_2 ',nbfreem0_in_lx_2
!             print*,'nb_going_West    ',nb_going_West
!             print*,'np_going_West    ',np_going_West
!             stop
!           endif
!         if(ii.le.nb_going_West)then        
!          i = iBP_going_West(ii)
        else
          i = iFP_going_West(ii-nb_going_West)
!           if(i_particleType(i).ne.4)then
!             print*
!             print*,'ERROR in SendRecv_Data_toWest'
!             print*,'i_particleType(i).ne.4'
!             print*,'ii, i, i_particleType(i) ',ii, i, i_particleType(i)
!             print*,'xp(i), zp(i) ',xp(i), zp(i)
!             print*,'nbf_in_lx_2     ',nbf_in_lx_2
!             print*,'nbfm_in_lx_2    ',nbfm_in_lx_2
!             print*,'nbfreem_in_lx_2 ',nbfreem_in_lx_2
!             print*,'nbf0_in_lx_2     ',nbf0_in_lx_2
!             print*,'nbfm0_in_lx_2    ',nbfm0_in_lx_2
!             print*,'nbfreem0_in_lx_2 ',nbfreem0_in_lx_2
!             print*,'nb_going_West    ',nb_going_West
!             print*,'np_going_West    ',np_going_West
!             stop
!           endif
        end if                
        P_xyz_data_going_West(ii,1)  = xp(i)
c                                    = yp        
        P_xyz_data_going_West(ii,2)  = zp(i)                
        P_data_going_West(ii,1)  = up(i)
c                                = vp        
        P_data_going_West(ii,2)  = wp(i)        
        P_data_going_West(ii,3)  = rhop(i)
        P_data_going_West(ii,4)  = p(i)        
        P_data_going_West(ii,5)  = pm(i)        
        P_data_going_West(ii,6)  = pVol(i)        
        P_data_going_West(ii,7)  = cs(i)                
        P_data_going_West(ii,8)  = dudx_CSPH(i)
c                                  dudy_CSPH(i)
        P_data_going_West(ii,9)  = dudz_CSPH(i)
c                                  dvdx_CSPH(i)
c                                  dvdy_CSPH(i)
c                                  dvdz_CSPH(i)
        P_data_going_West(ii,10) = dwdx_CSPH(i)
c                                  dwdy_CSPH(i)
        P_data_going_West(ii,11) = dwdz_CSPH(i)
        P_data_going_West(ii,12) = drhodx_CSPH(i)
c                                  drhody_CSPH(i)
        P_data_going_West(ii,13) = drhodz_CSPH(i)
        P_data_going_West(ii,14) = dTEdx_CSPH(i)
c                                  dTotalEdy_CSPH(i)
        P_data_going_West(ii,15) = dTEdz_CSPH(i)
        Tau_data_going_West(ii,1) = tau_xx_uno_rho2(i)
c                                 = tau_xy
        Tau_data_going_West(ii,2) = tau_xz_uno_rho2(i)
c                                 = tau_yy
c                                 = tau_yz
        Tau_data_going_West(ii,3) = tau_zz_uno_rho2(i)
        if(ii.le.nb_going_West)then        
          BP_data_going_West(ii,1) = xnb(i)
c                                  = ynb
          BP_data_going_West(ii,2) = znb(i)
          BP_data_going_West(ii,3) = xtb(i)
c                                  = ytb
          BP_data_going_West(ii,4) = ztb(i)
c                                  = xsb
c                                  = ysb
c                                  = zsb
          BP_data_going_West(ii,5)  = deltaptb(i,1)
          BP_data_going_West(ii,6)  = deltaptb(i,2)
c                                   = deltapsb(i,1)
c                                   = deltapsb(i,2)
          iabsolute_BP_going_West(ii) = iabsolute_BP_Pointer_index(i)          
        end if
        !-- Debug Code------
        if(rank_id.eq.0.and.itime.ge.itime_check)then
          print*,'ii, i',ii, i
c          print*,'xp(i), yp(i) ',
c     &            xp(i), yp(i) 
          print*,
     &          'P_xyz_data_going_West(ii, 1 & 2)  '
          print*,P_xyz_data_going_West(ii,1),
     &           P_xyz_data_going_West(ii,2)
     
!           print*,
!      &          'P_data_going_West(ii,1), P_data_going_West(ii,2) '
!           print*,P_data_going_West(ii,1), P_data_going_West(ii,2),
!      &           P_data_going_West(ii,3), P_data_going_West(ii,4)
!           print*,P_data_going_West(ii,5)
!           print*,P_data_going_West(ii,6), P_data_going_West(ii,7)
          
          if(i_particleType(i).le.2)then
            print*,'iabsolute_BP_going_West(ii) ',
     &              iabsolute_BP_going_West(ii)
          end if
        end if
      end do
     
      !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
            
c            
c      !- Send to West Neighbour -
      call MPI_SENDRECV(
     & iabsolute_BP_going_West, nb_going_West , MPI_INTEGER, west, 131,
     & iabsolute_BP_from_East , nb_from_East  , MPI_INTEGER, east, 131,
     & grid_comm, status, ierr)      
      !---Combined SendRecv's to West Neighbour ---
      call MPI_SENDRECV(
     &  P_xyz_data_going_West  , 1 , iP_xyzDataTypeA, west, 143,
     &  P_xyz_data_from_East   , 1 , iP_xyzDataTypeA, east, 143,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  P_data_going_West   , 1 , iP_DataTypeSR , west, 144,
     &  P_data_from_East    , 1 , iP_DataTypeSR , east, 144,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  BP_data_going_West, 1 , iBP_DataType  , west, 145,
     &  BP_data_from_East , 1 , iBP_DataType  , east, 145,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  Tau_data_going_West, 1 , iTau_DataType  , west, 146,
     &  Tau_data_from_East , 1 , iTau_DataType  , east, 146,
     &  grid_comm, status, ierr)

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'In SendRecv_Data'
c          print*,'Particles numbers to be swapped'
c        end if
c        do i=0,n_procs-1
c          if(i.eq.-rank_id)then
c            write(*,*)
c            write(*,*),'rank_id ', rank_id
c            write(*,*),'nb_going_East ',nb_going_East
c            write(*,*),'np_going_East ',np_going_East
c            write(*,*),'nb_going_West ',nb_going_West
c            write(*,*),'np_going_West ',np_going_West
c            write(*,*),'nb_from_East ',nb_from_East
c            write(*,*),'np_from_East ',np_from_East
c            write(*,*),'nb_from_West ',nb_from_West
c            write(*,*),'np_from_West ',np_from_West
c          end if
c          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c        end do
c      end if



496   format(i5,3('     ',i5,'  '),'  ',2('   ',e12.6))  

      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
                       
      !-- Debug Code------
      if(rank_id.eq.0.and.itime.ge.itime_check)then
        print*
        print*,'Unpacking Particle Data from East'
        print*,'rank_id, itime, np_from_East ',
     &          rank_id,itime,np_from_East
        print*,'nbf_local       ',nbf_local
        print*,'nbfm_local ',nbfm_local
        print*,'nbfreem_local     ',nbfreem_local
        print*,'nb_local        ',nb_local
        print*,'nbf_from_East       ',nbf_from_East
        print*,'nbfm_from_East ',nbfm_from_East
        print*,'nbfreem_from_East     ',nbfreem_from_East
        print*,'nb_from_East        ',nb_from_East
        print*,'nbf_image_local       ',nbf_image_local
        print*,'nbfm_image_local ',nbfm_image_local
        print*,'nbfreem_image_local     ',nbfreem_image_local
        print*,'nb_image_local        ',nb_image_local
        print*,'nbf_image_temp       ',nbf_image_temp
        print*,'nbfm_image_temp ',nbfm_image_temp
        print*,'nbfreem_image_temp     ',nbfreem_image_temp
        print*,'nb_image_temp        ',nb_image_temp
        print*,'np_local ',np_local
        print*,'kk_highest ',kk_highest
        print*,'ii, i_image, nb/FP_image_temp, ip_index_#P_local,
     &xp(i_image), zp(i_image)'
      end if
      !-- Unpack Particle data --
      do ii=1,np_from_East
        !i_image = np_local + np_from_West + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_West + ii
        i_image = kk_highest + ii
        xp(i_image)             = P_xyz_data_from_East(ii,1)
c       yp
        zp(i_image)             = P_xyz_data_from_East(ii,2)
        up(i_image)             = P_data_from_East(ii,1)
c       vp
        wp(i_image)             = P_data_from_East(ii,2)
        rhop(i_image)           = P_data_from_East(ii,3)
        p(i_image)              = P_data_from_East(ii,4)
        pm(i_image)             = P_data_from_East(ii,5)
        pVol(i_image)           = P_data_from_East(ii,6)
        cs(i_image)             = P_data_from_East(ii,7)
        dudx_CSPH(i_image)      = P_data_from_East(ii,8)
c       dudy_CSPH(i_image)        
        dudz_CSPH(i_image)      = P_data_from_East(ii,9)
c       dvdx_CSPH(i_image)        
c       dvdy_CSPH(i_image)        
c       dvdz_CSPH(i_image)        
        dwdx_CSPH(i_image)      = P_data_from_East(ii,10)
c       dwdy_CSPH(i_image)        
        dwdz_CSPH(i_image)      = P_data_from_East(ii,11)
        drhodx_CSPH(i_image)    = P_data_from_East(ii,12)
c       drhody_CSPH(i_image)        
        drhodz_CSPH(i_image)    = P_data_from_East(ii,13)
        dTEdx_CSPH(i_image)     = P_data_from_East(ii,14)
c       dTEdy_CSPH(i_image)        
        dTEdz_CSPH(i_image)     = P_data_from_East(ii,15)
        tau_xx_uno_rho2(i_image) = Tau_data_from_East(ii,1)
c       tau_xy                   = Tau
        tau_xz_uno_rho2(i_image) = Tau_data_from_East(ii,2)
c       tau_yy                   = Tau
c       tau_yz                   = Tau
        tau_zz_uno_rho2(i_image) = Tau_data_from_East(ii,3)
        iflag(i_image) = 1
        !-- Append to ip_index pointer arrays --
        if(ii.le.nb_from_East)then
          if(i_image.gt.nb_max)then
            print*
            print*,'ERROR in SendRecv_Data_2D.f'
            print*,'i_image.gt.nb_max '
            print*,'Adjust nb_max in common.2D'
            print*,'rank_id, itime ',rank_id, itime
            print*,'i_image   ',i_image
            print*,'nb_max    ',nb_max
            print*
            stop
          endif
          nb_image_temp = nb_image_temp + 1
          ip_index_BP_local(nb_image_temp) = i_image
          !Normals
          xnb(i_image)        = BP_data_from_East(ii,1)
c         ynb
          znb(i_image)        = BP_data_from_East(ii,2)
          xtb(i_image)        = BP_data_from_East(ii,3)
c         ytb
          ztb(i_image)        = BP_data_from_East(ii,4)
c         xsb
c         ysb
c         zsb
          deltaptb(i_image,1) = BP_data_from_East(ii,5)
          deltaptb(i_image,2) = BP_data_from_East(ii,6)
c         deltapsb(i_image,1)
c         deltapsb(i_image,2)
          iabsolute_BP_Pointer_index(i_image)=iabsolute_BP_from_East(ii)
          !- Array & Pointer printout -
          if(rank_id.eq.0.and.itime.ge.itime_check)then
            write(*,496),ii, i_image, nb_image_temp,  
     &       ip_index_BP_local(nb_image_temp),xp(i_image), zp(i_image)
            print*,'P_data_from_East'
            write(*,*)P_xyz_data_from_East(ii,1),
     &                P_xyz_data_from_East(ii,2)
            
!             write(*,*)P_data_from_East(ii,1), P_data_from_East(ii,2)
!             write(*,*)P_data_from_East(ii,3), P_data_from_East(ii,4)
!             write(*,*)P_data_from_East(ii,5), P_data_from_East(ii,6)
!             write(*,*)P_data_from_East(ii,7)
            write(*,*)'iabsolute_BP_Pointer_index(i_image) ',
     &                 iabsolute_BP_Pointer_index(i_image)
          end if
          !- Indexing -
          nb_image_temp2 = nb_image_temp - nb_local
          if(nb_image_temp2.le.nbf_from_East)then
            i_particleType(i_image) = 1   !Fixed Boundary Particle
            nbf_image_temp = nbf_image_temp + 1
            ip_index_BP_local_1(nbf_image_temp) = i_image
          else if(nb_image_temp2.le.nbfm_from_East)then
            i_particleType(i_image) = 2   !Forced Moving Boundary Particle
            nbfm_image_temp = nbfm_image_temp + 1
            ip_index_BP_local_2(nbfm_image_temp) = i_image
          else if(nb_image_temp2.le.nbfreem_from_East)then
            i_particleType(i_image) = 3   !Free Moving Boundary Particle
            nbfreem_image_temp = nbfreem_image_temp + 1
            ip_index_BP_local_3(nbfreem_image_temp) = i_image
          end if
        else
          nFP_image_temp = nFP_image_temp + 1
          ip_index_FP_local(nFP_image_temp) = i_image
          !- Array & Pointer printout -
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-12)then
            write(*,496),ii, i_image, nFP_image_temp,  
     &       ip_index_FP_local(nFP_image_temp),xp(i_image), zp(i_image)
            print*,'P_data_from_East'
            write(*,*)P_xyz_data_from_East(ii,1),
     &                P_xyz_data_from_East(ii,2)
c            
c            write(*,*)P_data_from_East(ii,1), P_data_from_East(ii,2)
c            write(*,*)P_data_from_East(ii,3), P_data_from_East(ii,4)
c            write(*,*)P_data_from_East(ii,5), P_data_from_East(ii,6)
c            write(*,*)P_data_from_East(ii,7)
          end if
          i_particleType(i_image) = 4   !Fluid Particle
        end if
        if(n_procs_z.gt.1.or.iCartTop_periodicity(3))then   !- 2-D & 3-D MPI Cartesian Topology -
          if(zp(i_image).lt.zmin_rank+two_h)then
            if(i_particleType(i_image).lt.4)then          !Boundary Particle
              if(i_particleType(i_image).lt.2)then        !Fixed BP 
                nbf_in_lz_2_temp = nbf_in_lz_2_temp + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbf0_in_lz_2 = nbf0_in_lz_2 + 1
                iBP_going_Below_1(nbf0_in_lz_2) = i_image
              else if(i_particleType(i_image).lt.3)then   !Forced Moving BP
                nbfm_in_lz_2_temp  = nbfm_in_lz_2_temp  + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbfm0_in_lz_2 = nbfm0_in_lz_2 + 1
                iBP_going_Below_2(nbfm0_in_lz_2) = i_image
              else !if(i_particleType(i_image).eq.3)then    !Free moving BP
                nbfreem_in_lz_2_temp  = nbfreem_in_lz_2_temp  + 1
                nb_in_lz_2 = nb_in_lz_2 + 1
                nbfreem0_in_lz_2 = nbfreem0_in_lz_2 + 1
                iBP_going_Below_3(nbfreem0_in_lz_2) = i_image
              end if                
              iBP_going_Below(nb_in_lz_2) = i_image
            else if(i_particleType(i_image).eq.4)then      !Fluid Particle
              nFP_in_lz_2  = nFP_in_lz_2   + 1
                if(nFP_in_lz_2.gt.nGuestmax)then
                  print*
                  print*,'ERROR in SendRecv_Data_toWest.f'
                  print*,'nFP_in_lz_2.gt.nGuestmax'
                  print*,'rank_id, itime ',rank_id, itime
                  print*,'nFP_in_lz_2 ',nFP_in_lz_2
                  print*,'nGuestmax    ',nGuestmax
                  print*,'Increase nGuestmax in common_MPI.3D'
                  call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
                  stop
                end if
              iFP_going_Below(nFP_in_lz_2) = i_image
            endif
          endif
        endif
c        !-- Debug Code------
c        if(rank_id.eq.0.and.itime.ge.itime_check)then
c          print*,'i_particleType(i_image) ',i_particleType(i_image)
c          print*
c        endif
      end do

      kk_highest_after_SR_toWest = kk_highest + np_from_East

      if(ndim.gt.1)then
        !Make numbers absolute in reference to start of local list
        !This makes the nomenclature consistent
        nbf_in_lz_2 = nbf_in_lz_2  + nbf_in_lz_2_temp
        nbfm_in_lz_2 = nbfm_in_lz_2 + nbf_in_lz_2_temp
     &                              + nbfm_in_lz_2_temp
        nbfreem_in_lz_2 = nbfreem_in_lz_2 + nbf_in_lz_2_temp
     &                                    + nbfm_in_lz_2_temp
     &                                    + nbfreem_in_lz_2_temp
        np_in_lz_2 = nFP_in_lz_2  + nb_in_lz_2
c        nbfm_in_lz_ncz_localminus1 = nbf_in_lz_ncz_localminus1 
c     &                            + nbfm_in_lz_ncz_localminus1
c        nbfreem_in_lz_ncz_localminus1 = nbfm_in_lz_ncz_localminus1 
c     &                             + nbfreem_in_lz_ncz_localminus1
c        np_in_lz_ncz_localminus1 = nFP_in_lz_ncz_localminus1
c     &                           + nb_in_lz_ncz_localminus1
        nb_going_Above = nb_in_lz_ncz_localminus1
        np_going_Above = np_in_lz_ncz_localminus1
        nb_going_Below = nb_in_lz_2
        np_going_Below = np_in_lz_2
      endif      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
!       !-- Printout Check for Image
!       if(itime.ge.itime_check.and.rank_id.eq.irank_check)then
!       !if(itime.ge.0.and.rank_id.eq.2)then
!         print*
!         print*,'rank_id         ',rank_id
!         print*,'itime           ',itime
!         print*,'nbf_local       ',nbf_local
!         print*,'nbfm_local ',nbfm_local
!         print*,'nbfreem_local     ',nbfreem_local
!         print*,'nb_local        ',nb_local
!         print*,'np_local        ',np_local
!         print*,'nbf_from_West ',nbf_from_West
!         print*,'nbf_from_East ',nbf_from_East
!         print*,'nbfm_from_West  ',nbfm_from_West
!         print*,'nbfm_from_East  ',nbfm_from_East
!         print*,'nbfreem_from_West  ',nbfreem_from_West
!         print*,'nbfreem_from_East  ',nbfreem_from_East
!         print*,'nb_from_West    ',nb_from_West
!         print*,'nb_from_East    ',nb_from_East
!         print*,'np_from_West    ',np_from_West
!         print*,'np_from_East    ',np_from_East
!         print*,'nbf_image_local ',nbf_image_local
!         print*,'nbfm_image_local  ',nbfm_image_local
!         print*,'nbfreem_image_local      ',nb_image_local
!         print*,'nb_image_local   ',nb_image_local
!         print*,'np_image_local   ',np_image_local
!         print*,'nb_image_temp    ',nb_image_temp
!         print*,'nFP_image_temp   ',nFP_image_temp
!         if(1.eq.1)then
!           !do ipcount=1,np_image_local
!           do ipcount=np_local + 1,np_image_local
!             if(ipcount.le.nbf_image_local)then
!               i = ip_index_BP_local_1(ipcount)
!             else if(ipcount.le.nbfm_image_local)then
!               i = ip_index_BP_local_2(ipcount-nbf_image_local)
!             else if(ipcount.le.nbfreem_image_local)then
!               i = ip_index_BP_local_3(ipcount-nbfm_image_local)
!             else
!               i = ip_index_FP_local(ipcount-nb_image_local)
!             end if
!             write(*,494),'ipcount -> i, xp, zp ',
!      &                  ipcount,i,xp(i),zp(i)
!           end do
!         end if
!         print*,'nb_going_Below0, nb_going_Below ',
!      &          nb_going_Below0, nb_going_Below
!         print*,'np_going_Below0, np_going_Below ',
!      &          np_going_Below0, np_going_Below
!         print*,'zmin_rank       ',zmin_rank
!         print*,'zmin_rank+two_h ',zmin_rank+two_h
!         if(itime.ge.1)stop
!         !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       end if
!494   format(1(a21,'  '),2(i6,'  '),2(f16.10,' '))
!495   format(2(i6,'  '),8(f10.6,' '))

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(1.eq.2.and.rank_id.eq.1.and.itime.ge.itime_check)then
c        print*
c        print*,'Image Normals, end of SendRecv_Data, rank_id ',rank_id
c        print*,
c     &' i    xp     zp     xnb     znb   deltaptb(i,1)   deltaptb(i,2)'
c        do ipcount = 1, nb_image_local 
c          i = ip_index_BP_local(ipcount)
c          write(*,495),ipcount,i,xp(i),zp(i),xnb(i),znb(i),
c     &               xtb(i),ztb(i),deltaptb(i,1),deltaptb(i,2)
c        end do
c        print*
c      end if
      
      !stop
      
      end subroutine
