c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine SendRecv_MLS_Matrices_toWest
c
      include 'common.2D'
              
      real beta_MLS_going_West(nGuestmax,3) 
      real beta_MLS_from_East(nGuestmax,3)

      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, east, west ',rank_id, east, west 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idx.eq.0
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nb_going_West = 0
        np_going_West = 0
        if(n_procs_x.eq.1)then
          nb_going_East = 0
          np_going_East = 0
        end if
      else if(rank_idx.eq.n_procs_x-1
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nb_going_East = 0
        np_going_East = 0
        if(n_procs_x.eq.1)then
          nb_going_West = 0
          np_going_West = 0
        end if
      end if

                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---


c      if(itime.ge.itime_check.and.rank_id.eq.1)then
c        print*
c        print*,'Packing Particle Data to go West'
c        print*,'rank_id, np_in_lx_2, nb_going_West, np_going_West ',
c     &          rank_id, np_in_lx_2, nb_going_West, np_going_West
c      end if
      nbfm_start    = nbf_in_lx_2 + 1
      nbfreem_start = nbfm_in_lx_2 + 1
      nFP_start     = nb_going_West + 1
      do ii=1,np_going_West     !do ii=1,np_in_lx_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_West_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_West_2(ii-nbf0_in_lx_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_West_3(ii-(nbf0_in_lx_2+nbfm0_in_lx_2))
        !if(ii.le.nb_going_West)then        
        !  i = iBP_going_West(ii)
        else
          i = iFP_going_West(ii-nb_going_West)
        end if                
        beta_MLS_going_West(ii,1) = beta0_MLS(i)            
        beta_MLS_going_West(ii,2) = beta1x_MLS(i)            
        beta_MLS_going_West(ii,3) = beta1z_MLS(i)  
          
c          if(itime.ge.itime_check.and.rank_id.eq.0)then
c            print*,
c     &      ii,i_image,xp(i_image),zp(i_image),
c     &      beta_MLS_going_West(ii,1)
c          end if         
        end do  
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      !Send data back West
        call MPI_SENDRECV(
     &   beta_MLS_going_West, 1,  iMLS_DataType2  , west, 1,
     &   beta_MLS_from_East , 1,  iMLS_DataType2  , east, 1,
     &   grid_comm, status, ierr)
            
            
      !-- Unpack Data & Update summations on original processors
      
 
      !-- UnPack Particle data from East--
!       if(itime.ge.itime_check.and.rank_id.eq.4)then
!         print*,'Unpacking data originally sent West'
!         print*,'np_from_East ',np_from_East
!         print*,'Summing sum_wab'
!         print*,'ii, i, sum_wab(i), beta_MLS_from_East(ii,1)'
!       end if
      do ii=1,np_from_East
        i_image = kk_highest + ii   !For kk_highest, see index_check.f
        beta0_MLS (i_image) = beta_MLS_from_East(ii,1)
        beta1x_MLS(i_image) = beta_MLS_from_East(ii,2)
        beta1z_MLS(i_image) = beta_MLS_from_East(ii,3)

c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,494),ii, i, sum_wab(i), beta_MLS_from_East(ii,1)
c        end if        
      end do

494   format(2(i5,'    '),4(f12.6,'    '))      
495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
