c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac_MLS
c
      include 'common.2D'

      !print*,'ac_MLS, itime, i_MLS_part ',itime, i_MLS_part

      !-- X-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(1).or.
     &   (rank_idx.gt.0.and.rank_idx.lt.n_procs_x-1))then
        ncx_start = 2
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.0)then
        ncx_start = 1
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.n_procs_x-1)then
        ncx_start = 2
        ncx_finish = ncx_local
      else !Just incase-error catching
        ncx_start = 2
        ncx_finish = ncx_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idz ',
     &          rank_idx, rank_idz
        print*,'ncx_start = ',ncx_start
        print*,'ncx_finish= ',ncx_finish
        stop
      end if
      !-- Z-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(3).or.
     &   (rank_idz.gt.0.and.rank_idz.lt.n_procs_z-1))then
        ncz_start = 2
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.0)then
        ncz_start = 1
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.n_procs_z-1)then
        ncz_start = 2
        ncz_finish = ncz_local
      else if(ndim.eq.2.and.n_procs_x.eq.1)then
        if(rank_idz.eq.0)then
          ncz_start = 1
          ncz_finish = ncz_local - 1
        elseif(rank_idz.lt.n_procs_z-1)then
          ncz_start = 2
          ncz_finish = ncz_local-1
        else   !if(rank_idz.eq.n_procs_z-1)then
          ncz_start = 2
          ncz_finish = ncz_local
        endif
      else !Just incase-error catching
        ncz_start = 2
        ncz_finish = ncz_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idz ',
     &          rank_idx, rank_idz
        print*,'ncz_start = ',ncz_start
        print*,'ncz_finish= ',ncz_finish
        stop
      end if
c     ncy_start = 1
c     ncy_finish = ncy_local
c     ncz_start = 1
c     ncz_finish = ncz_local
      lz2_min = ncz_start + 1  !2
       
c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.1)then
c        print*
c        print*,'In AC.f before pre_celij_MLS calls'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp ',up(i),wp(i)
c        print*,'ax, az ',ax(i),az(i)
c        print*,'ar     ',ar(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*
c      end if
       
      ly2 = 0   !Default Y-Periodic value
       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1  !Gives the alternative value to kind_p2 of kind_p1
              
       do lz=ncz_start,ncz_finish
       do lx=ncx_start,ncx_finish
       
       
         j1 = lx + (lz-1)*ncx_local

         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

c         print*,'kind_p1, lx, lz, j1 ',kind_p1,lx, lz, j1

c         !-- Cells in the same XY sheet --
          lx2 = lx+1
          lz2 = lz+1
          

          !- Special correction for MPI Cartesian Topology -
          lx2t = lx2
          lz2t = lz2

          if(iCartTop_periodicity(1))then
            lx2t = lx2t+1   !Add one to activate periodicity correction 
          endif
c         if(iCartTop_periodicity(2))then
c           ly2t = ly2t+1   !Add one to activate periodicity correction 
c         endif
          if(iCartTop_periodicity(3))then
            lz2t = lz2t+1   !Add one to activate periodicity correction
          endif
          !------------------------------------------------
          
          !- EAST -
          if(lx2.le.ncx_local)then
            call pre_celij_MLS(j1,j1+1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,1)     !East
          end if

          !- NORTH -
          if(lz2.le.ncz_local)then
            call pre_celij_MLS(j1,j1+ncx_local,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,3)     !North
          !- NORTH-EAST -  
            if(lx2.le.ncx_local)then 
            call pre_celij_MLS(j1,j1+ncall2,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,5)     !North-East
            endif
          endif

          !- SOUTH-EAST -
          if(lx2.le.ncx_local.and.lz2.gt.lz2_min)then
            call pre_celij_MLS(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,9)     !South-East
          endif

          !-- PERIODIC CALLS ---
               
          !-- Cells in the same XZ sheet --
          !- X-Dir Periodic -
          if(i_periodicOBs(1).eq.1.and.lx.eq.ncx_local)then
            call pre_celij_MLS(j1,j1+1-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,2)                        !East        Periodic X-Dir only
            if(lz2.le.ncz_local)then
              call pre_celij_MLS(j1,j1+ncall2-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,6)                        !North-East  Periodic X-Dir only
            endif
            if(lz2.gt.2)then
              call pre_celij_MLS(j1,j1+ncall1-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,10)                       !South-East  Periodic X-Dir only
            endif
            if(i_periodicOBs(3).eq.1)then
              if(lz.eq.ncz_local)then
                call pre_celij_MLS(j1,j1+ncall2-ncx_local-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,7)                        !North-East  Periodic X-Dir & Z-Dir
              else if(lz.eq.1)then
                call pre_celij_MLS(j1,j1+ncall1-ncx_local+nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,11)                       !South-East  Periodic X-Dir & Z-Dir
              endif
            endif
          endif
          !- Z-Dir Periodic Only -
          if(i_periodicOBs(3).eq.1)then 
            if(lz.eq.ncz_local)then
              call pre_celij_MLS(j1,j1+ncx_local-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,4)                        !North       Periodic Z-Dir only
              if(lx2.le.ncx_local)then
                call pre_celij_MLS(j1,j1+ncall2-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,8)                        !North-East  Periodic Z-Dir only
              end if
            endif
            if(lz2.eq.2.and.lx2.le.ncx_local)then
              call pre_celij_MLS(j1,j1+ncall1+nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,12)                       !South-East  Periodic Z-Dir only
            end if
          end if

        endif  !End of: if(nc(j1,kind_p1).gt.0)then

      enddo
      enddo


      !- Extra SOUTH-EAST for Z-dir Cartesian MPI Topology -
      if(n_procs_z.gt.1.and.rank_idz.lt.n_procs_z-1)then
        lz=ncz_finish + 1
        do lx=ncx_start,ncx_finish
c      
          j1 = lx + (lz-1)*ncx_local
          if(nc(j1,kind_p1).gt.0) then
c           !-- Cells in the same XY sheet --
            lx2 = lx+1
            lz2 = lz+1

            !- Special correction for MPI Cartesian Topology -
            lx2t = lx2
            lz2t = lz2
       
            if(iCartTop_periodicity(1))then
              lx2t = lx2t+1   !Add one to activate periodicity correction 
            endif
c           if(iCartTop_periodicity(2))then
c             ly2t = ly2t+1   !Add one to activate periodicity correction 
c           endif
            if(iCartTop_periodicity(3))then
              lz2t = lz2t+1   !Add one to activate periodicity correction
            endif
            if(lx2.le.ncx_local)then
              call pre_celij_MLS(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,13)     !South-East
            endif
          endif
        enddo
c
      endif

       
       do j1x = ncx_start, ncx_finish
       do j1z = ncz_start, ncz_finish
       
         j1 = j1x + (j1z-1)*ncx_local
           if(nc(j1,kind_p1).gt.0)
     +        call pre_self_MLS(j1,kind_p1,ini_kind_p2)
       enddo
       enddo
       
       
       enddo   !End of:  do kind_p1=1,2
       
      !print*,'ac_MLS, BEFORE update_MLS_Summations'
      !SendRecv all acceleration summations back to origin processors
      if(i_MLS_part.eq.1)then
c       if(i_call_NorthSouth.eq.1) call update_MLS_Summations_fromSouth  !3-D only
        if(i_call_UpDown    .eq.1) call update_MLS_Summations_fromBelow
        call update_MLS_Summations_fromWest
      endif
      if(i_MLS_part.eq.2)then
c       if(i_call_NorthSouth.eq.1)then
c         call update_MLS_densitySummations_fromSouth  !3-D only
c       endif
        if(i_call_UpDown    .eq.1)then
          call update_MLS_densitySummations_fromBelow
        endif
        call update_MLS_densitySummations_fromWest
      endif

      return
      end
       
