c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine check_limits_2D
      
      include 'common.2D'
      
      double precision dxp_dble, dzp_dble
       
       
       zmax=0
       ncases=0
       
       !- Periodicity should be handled by INDEX_CHECK
       do ipcount=nb_local + 1,np_local ! Check if any fluid particle is over the box
         i=ip_index_FP_local(ipcount - nb_local)
          if(zp(i).gt.zmax) zmax=zp(i)
          if(iflag(i).eq.1)then
            if(xp(i).gt.xmax_container.or.
     &         xp(i).lt.xmin_container) then   
              if(i_periodicOBs(1).ne.1.and.
     &           (.NOT.iCartTop_periodicity(1)) )then  !Replace Particle on other side of domain
                print*,'Particle leaving, rank_id, itime ',rank_id,itime
                print*,'i, xp, zp ',i,xp(i),zp(i)   
                iflag(i)=0
                ncases=ncases+1
                xp(i)=xtrash
                !zp(i)=ztrash
                up(i)=0.
                wp(i)=0.
                um1(i)=0.
                uo(i)=0.
                wm1(i)=0.
                wo(i)=0.
              endif
            else if(zp(i).gt.zmax_container.or.
     &              zp(i).lt.zmin_container)then
              if(i_periodicOBs(3).ne.1.and.
     &           (.NOT.iCartTop_periodicity(3)) )then  !Replace Particle on other side of domain
                print*,'Particle leaving, rank_id, itime ',rank_id,itime
                print*,'i, xp, zp ',i,xp(i),zp(i)   
                iflag(i)=0
                ncases=ncases+1
                !xp(i)=xtrash
                zp(i)=ztrash
                up(i)=0.
                wp(i)=0.
                um1(i)=0.
                uo(i)=0.
                wm1(i)=0.
                wo(i)=0.
              end if
            end if
                
         endif   
       enddo
       
     
c       !- Commented out for parallel code - 
c       if(1.eq.2)then 
c         nn=nint((zmax-zmax_ini)*one_over_2h)
c       
c         if (nn.gt.0) then         
c          zmax = zmax_ini + 2*h*nn
c          ncz = int( (zmax-zmin)/(2.*h) ) + 1
c          nct = ncx*ncz !2D
c          do i=nct_ini+1,nct
c             nc(i,1)  = 0 !No Boundary Particles in these cells
c          enddo
c         else
c         zmax=zmax_ini
c         endif
c      endif      
       
      if (ncases.ne.0)then
        write(*,*) 'rank_id = ',rank_id,', Number=',ncases,' time',time
      endif
       
       
      return
       
       end