c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
c
c*********************************************************************
c
      subroutine movingPaddle(i_half_dt)

c
      include 'common.2D'
     
      real(kind=kind_XZ ) xp_togoto_Root(nb_max)
      real(kind=kind_XZ ) zp_togoto_Root(nb_max)
      
      integer i_BPP_togoto_Root(nb_max)
      
      
c     i_half_dt = 1,2  depending on whether subroutine is being called 
c                      during the first/second half of the timestep


      i_gotoRoot = 0  !Default value for NOT updating Normal info on root
      if(i_paddleType.eq.1)then
c       ---  Piston paddle ---                      
           
        if (time.gt.(twinitial(ind_wm)+twinitial(ind_wm+1))*0.5) then

          ind_wm=ind_wm+1
          ind1_wm=ind_wm+1
        endif


c       twopi_o_Period=twopi/Period(ind_wm)
c       twopi_o_Period1=twopi/Period(ind1_wm)

c       write(*,*), time, twopi_o_Period, twopi_o_Period1

c       wm_coeff1=(1-tanh(time-twinitial(ind_wm)))
c       wm_coeff2=(1+tanh(time-twinitial(ind_wm)))

       if(Nfreq.gt.1)then

        do ipcount=nwavemaker_ini,nwavemaker_end

          i = ip_index_BP_local(ipcount)
          xp(i)=xp_ini(i)+
     +     0.5*(A_wavemaker(ind_wm)*(1-tanh(time-twinitial(ind_wm)))*
     +        sin(2*pi*(time-twinitial(ind_wm))/Period(ind_wm))+
     +        A_wavemaker(ind1_wm)*(1+tanh(time-twinitial(ind_wm)))*
     +        sin(2*pi*(time-twinitial(ind1_wm))/Period(ind1_wm)))

          up(i)=0.5*2*pi*((A_wavemaker(ind_wm)/Period(ind_wm))*
     +        (1-tanh(time-twinitial(ind_wm)))*
     +        cos(2*pi*(time-twinitial(ind_wm))/Period(ind_wm))+
     +        (A_wavemaker(ind1_wm)/Period(ind1_wm))*
     +        (1+tanh(time-twinitial(ind_wm)))*
     +        cos(2*pi*(time-twinitial(ind1_wm))/Period(ind1_wm)))
        
        enddo
       else
         wave_freq = 2.0*pi/Period(1)
        do ipcount=nwavemaker_ini,nwavemaker_end

          i = ip_index_BP_local(ipcount)
          xp(i)=xp_ini(i)+
     +        A_wavemaker(1)*sin(wave_freq*time)

          up(i)=wave_freq*A_wavemaker(1)*cos(wave_freq*time)

        enddo
         
       endif
        
       i_gotoRoot = 1
        
      else if(i_paddleType.eq.2)then
c         ---  Piston-flap paddle ---             
        t = time          
        t_frac = 1.0   !t/Tr
        t_factor = 1.0
        !- Optional Ramp-up Function -
        !if(t_frac.lt.1.0)then
        !  t_factor = (-2.0*(t_frac**3) + 3.0*(t_frac**2))
        !else
        !  t_factor = 1.0
        !end if
        wave_freq = 2.0*pi/Period(1)
        
        !- Debugging Values -
        !xp_0 = xp(nbfm_local)
        !zp_0 = zp(nbfm_local)
        !up_0 = up(nbfm_local)
        !wp_0 = wp(nbfm_local)
        
        
        
        i_tgt_count = 0
        i_gotoRoot = 1
        do ipcount = 1,nb_local
         i = ip_index_BP_local(ipcount)
         if(i_particleType(i).eq.2)then   !Forced Boundary Particle Motion
          z_factor = 1.0 + (zp(i)-paddle_SWL)/
     &               (paddle_SWL + flap_length)
          xp(i) = X_PaddleCentre
     &            + z_factor*t_factor*0.5*stroke*cos(wave_freq*t)
          up(i) = -wave_freq
     &             *z_factor*t_factor*0.5*stroke*sin(wave_freq*t)   
        
          !Pack xyz data for sending to Root processor
          i_tgt_count = i_tgt_count + 1
          xp_togoto_Root(i_tgt_count)   = xp(i)
          zp_togoto_Root(i_tgt_count)   = zp(i)
          
          i_BPP_togoto_Root(i_tgt_count) =    !          i_BPP_togoto_Root(ipcount-nbf_local) = 
     &                 iabsolute_BP_Pointer_Index(i)
          
         endif   !End of:  if(i_particleType(iip).eq.2)then   !Forced Boundary Particle Motion
        end do
      
c       yp(iip) remains unchanged
c       zp(iip) remains unchanged
c       vp(iip) remains unchanged
c       wp(iip) remains unchanged
      
      else if(i_paddleType.eq.3)then
c         ---  Piston paddle with Prescribed Motion ---             
        t = time          
        i_tgt_count = 0
        !print*,'In movingPaddle, rank_id, itime ',rank_id, itime
        do ii = 2,n_paddleData
          if(t.gt.time_paddle(ii-1).and.t.le.time_paddle(ii))then
            t_factor = (t - time_paddle(ii-1))/
     &               (time_paddle(ii) - time_paddle(ii-1))
            ii_t = ii
            i_gotoRoot = 1
            !i_tgt_count = 0
            do ipcount = 1,nb_local
              i = ip_index_BP_local(ipcount)
              if(i_particleType(i).eq.2)then   !Forced Boundary Particle Motion
                xp(i) = x_paddle(ii-1)
     &               + t_factor*(x_paddle(ii)-x_paddle(ii-1))
                up(i) = u_paddle(ii-1)
     &               + t_factor*(u_paddle(ii)-u_paddle(ii-1))
          
                !Pack xyz data for sending to Root processor
                i_tgt_count = i_tgt_count + 1
                xp_togoto_Root(i_tgt_count)   = xp(i)
                zp_togoto_Root(i_tgt_count)   = zp(i)
                
                i_BPP_togoto_Root(i_tgt_count) = 
     &                  iabsolute_BP_Pointer_Index(i)
          
              endif   !End of:  if(i_particleType(iip).eq.2)then   !Forced Boundary Particle Motion
            end do
          endif   
        end do
      end if

      !- Error catching -
      if(i_tgt_count.gt.0.and.
     &   i_tgt_count.ne.nbfm_local - nbf_local)then
        print*
        print*,'ERROR in movingPaddle_MPI_2D.f'
        print*,'i_tgt_count.ne.nbfm_local - nbf_local'
        print*,'i_tgt_count     ',i_tgt_count
        print*,'nbf_local        ',nbf_local
        print*,'nbfm_local  ',nbfm_local
        print*,'nbMBP_local      ',nbMBP_local
        print*,'nb_local         ',nb_local
        print*,'np_local         ',np_local
        print*,'rank_id, itime  ',rank_id, itime
        print*,'num_FB     ',num_FB
        print*,'i_num_FB, i_FB_start, nb_FB_local(i_num_FB)'
        print*,'i_paddleType    ',i_paddleType
        print*,'time, t, t_factor ',time, t, t_factor
        print*,'ii_t,  time_paddle(ii_t-1), time_paddle(ii_t) ',
     &          ii_t,  time_paddle(ii_t-1), time_paddle(ii_t)
        print*,'i_gotoRoot ',i_gotoRoot
        print*
        print*,'Using ip_index_BP_local(ipcount)'
        print*,'ipcount = 1,nb_local     1 ',nb_local
        do ipcount = 1,nb_local
          i = ip_index_BP_local(ipcount)
          print*,'ipcount, i, i_particleType(i) ',
     &            ipcount, i, i_particleType(i)
        enddo
c        print*
c        print*,'Using ip_index_BP_local_1(ipcount)'
c        print*,'ipcount = 1,nbf_local    1 ',nbf_local
c        do ipcount = 1,nbf_local
c          i = ip_index_BP_local_1(ipcount)
c          print*,'ipcount, i, i_particleType(i) ',
c     &            ipcount, i, i_particleType(i)
c        enddo
c        print*
c        print*,'Using ip_index_BP_local_2(ipcount-nbf_local)'
c        print*,'ipcount = nbf_local + 1,nbfm_local ',
c     &                    nbf_local + 1,nbfm_local
c        do ipcount = nbf_local + 1,nbfm_local
c          i = ip_index_BP_local_2(ipcount-nbf_local)
c          print*,'ipcount, i, i_particleType(i) ',
c     &            ipcount, i, i_particleType(i)
c        enddo
c        print*
c        print*,'Using ip_index_BP_local_3(ipcount-nbfm_local)'
c        print*,'ipcount = nbfm_local+1,nbMBP_local ',
c     &                    nbfm_local+1,nbMBP_local
c        do ipcount = nbfm_local+1,nbMBP_local
c          i = ip_index_BP_local_3(ipcount-nbfm_local)
c          print*,'ipcount, i, i_particleType(i) ',
c     &            ipcount, i, i_particleType(i)
c        enddo
        stop
      endif
      
      if(i_gotoRoot.eq.1)call update_BPInfo_onRoot(
     &       nbf_local+1, nbfm_local, i_BPP_togoto_Root,
     &       xp_togoto_Root, zp_togoto_Root)

c     for MPI this is placed at end of step_##.f
c     Normals are calculated in subroutine updateNormals
c      if(iBC.eq.1)then   !Repulsive Force BC
c        call updateNormals_3D(nbfp1,nb)
c      end if

c          !- Debugging Code -
c        if(1.eq.2.and.rank_id.eq.0)then
c          i = nbfm_local
c          print*
c          print*,'WAVEMAKER POSITION'
c          print*,'i, itime    ',i,itime
c          print*,'nbfp1_local, nbfm_local ',
c     &            nbfp1_local, nbfm_local
c          print*,'xp_0   , zp_0   ',xp_0   , zp_0
c          print*,'up_0   , wp_0   ',up_0   , wp_0
c          print*,'xp(i), zp(i) ',xp(i), zp(i)
c          print*,'up(i), wp(i) ',up(i), wp(i)
c          print*,'i_tgt_count ',i_tgt_count
c          print*,'i_paddleType   ',i_paddleType
c          print*,'paddle_SWL     ',paddle_SWL
c          print*,'flap_length    ',flap_length
c          print*,'X_PaddleCentre ',X_PaddleCentre
c          print*,'wave_freq, t   ',wave_freq,t
c          if(itime.gt.0.and.i_paddleType.eq.2)then
c            print*,'z_factor, t_factor   ',z_factor, t_factor
c          endif
c          print*
c          if(itime.ge.11)stop
c        end if
      
      return            
      end
c
c*********************************************************************
c
