c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine step
c
      include 'common.2D'

      dt2 = 0.5*dt

c	Symplectic Method

c  ...  compute acceleration
c
      
c      !-- Debug Code------
!       itime_check = 10e8   !0    !10e8   !0    !
!       i_rank_check = 0
!       i_ParticleCheck = 1722   !1101   !nb_local + 1      

      if(rank_id.eq.0.and.itime/100*100 .eq. itime) then
        write(*,*) 'In step:   time = ',time,' itime = ',itime
      endif
       
       nb_image_local      = nb_local
       np_image_local      = np_local
       nbf_image_local     = nbf_local
       nbfm_image_local    = nbfm_local
       nbfreem_image_local = nbfreem_local
       nbp1_local  = nb_local + 1
       nfbp1_local = nbf_local + 1     

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'In step_Symplectic.f BEFORE anything'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp    ',up(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*,'pVol(i) ',pVol(i)
c        if(i.lt.nbp1)then
c          print*,'xnb, znb    ',xnb(i),znb(i)
c          print*,'xtb, ztb    ',xtb(i),ztb(i)
c
c        endif
c        print*,'nb_local ',nb_local
c        print*,'np_local ',np_local
c        print*,'nbf_image_local       = ',nbf_image_local
c        print*,'nbfm_image_local = ',nbfm_image_local
c        print*,'nbfreem_image_local     = ',nbfreem_image_local
c        print*,'nb_image_local ',nb_image_local
c        print*,'np_image_local ',np_image_local
c        if(1.eq.2)then
c          !-- Image Print-out --
c          do ipcount=1,np_local
c            if(ipcount.le.nbf_local)then
c              i = ip_index_BP_local_1(ipcount)
c            else if(ipcount.le.nbfm_local)then
c              i = ip_index_BP_local_2(ipcount-nbf_local)
c            else if(ipcount.le.nbfreem_local)then
c              i = ip_index_BP_local_3(ipcount-nbfm_local)
c            else
c              i = ip_index_FP_local(ipcount-nb_local)
c            end if
c            print*,'ipcount -> i, Type, xp, zp',
c     &                  ipcount,i,i_particleType(i),xp(i),zp(i)
c          end do
c        endif
c       print*
c      end if
       
c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_2D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here nad not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(0)   !argument 1 selects densityFilter option


      call ac         



c      !-- Debug Code------
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'AFTER AC, PREDICTOR, before CORRECT'
c        print*,'rank_id, itime, dt ',rank_id, itime, dt
c        i = i_ParticleCheck  
c        print*,'i = ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
cc       print*,'ay(i), Volrhov(i) '       
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
cc       print*,'drhody_CSPH(i)',drhody_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
cc       write(*,859)'ay(i) '
c        write(*,859)'az(i) ',az(i)
c      endif
c
c  ... compute corrections to:
c         (a) rate of change of velocity due to
c             (i)  body forces, and
c             (ii) boundary forces
c
c         (b) rate of change of position (free-surface, XSPH)
c
C
      call correct

c	To calculate time step 
      if (ivar_dt.eq.1) then
	    call variable_time_step  
	    ddt_p=dt_new
      endif
	

c
c  ... predictor
c

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
         xo(i)   = xp(i)
c        yo(i)   =         
         zo(i)   = zp(i)
         uo(i)   = up(i)
c        vo(i)   =         
         wo(i)   = wp(i)
         po(i)   = p(i)
         rhoo(i) = rhop(i)
         TEo(i)  = TEp(i)

         Volo(i)       = pVol(i)
         Volrhoo(i)    = Volrho(i)
         Volrhouo(i)   = Volrhou(i)
c        Volrhovo(i)   = 
         Volrhowo(i)   = Volrhow(i)
         VolTotalEo(i)  = VolTotalE(i)
      
      enddo

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
c  ...   Compute volume and density
         pVol(i) = Volo(i) + dt2*aVol(i)
         Volrho(i) = Volrhoo(i) + dt2*ar(i)
         rhop(i) = Volrho(i) / pVol(i)
      end do
      
      
      do ipcount=nb_local+1,np_local
         i = ip_index_FP_local(ipcount-nb_local)
         
         xp(i) = xo(i) + dt2*xdot(i)
c        yp(i) =          
         zp(i) = zo(i) + dt2*zdot(i)

         Volrhou(i) = Volrhouo(i) + dt2*ax(i)
c        Volrhov(i) =          
         Volrhow(i) = Volrhowo(i) + dt2*az(i)
         
         up(i) = Volrhou(i) /Volrho(i)
c        vp(i) = 
         wp(i) = Volrhow(i) /Volrho(i)
         
      enddo
      
      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
c  ...   Compute Total and thermal energy
         VolTotalE(i) = VolTotalEo(i) + dt2*aTE(i)
         TotalE(i) = VolTotalE(i) / pVol(i)
         TEp(i) = (TotalE(i)/rhop(i))
     &           - 0.5*(up(i)*up(i) + wp(i)*wp(i))
c  ...   compute pressure using the equation of state
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo
      
     
!       !-- Debug Code------
! c      print*,'C1, itime ',
! c     &        itime, rhop(i_ParticleCheck),pVol(i_ParticleCheck),
! c     &        p(i_ParticleCheck)
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         print*
!         print*,'AFTER CORRECT, PREDICTOR, before movingOBJECTS'
!         print*,'rank_id, itime, dt ',rank_id, itime, dt
!         print*,'ddt_p, dt, dt2 ',ddt_p, dt, dt2
!         i = i_ParticleCheck  
!         print*,'i = ',i
!         print*,'xp, zp  ',xp(i),zp(i)
!         print*,'up, wp  ',up(i),wp(i)
!         print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
!         print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
!         print*,'VolTotalE   , VolTotalEo ',
!      &          VolTotalE(i), VolTotalEo(i) 
!         print*,'aTE(i) ',aTE(i)
!         print*,'TEp, TotalE ',TEp(i),TotalE(i)
!         print*,'ar(i), aVol(i) ',ar(i), aVol(i)
!         print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
!         print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
! c       print*,'ay(i), Volrhov(i) '       
!         print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
!         print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
!         print*,'dudx_CSPH(i)',dudx_CSPH(i)
!         print*,'dudz_CSPH(i)',dudz_CSPH(i)
!         print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
!         print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
!         print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
! c       print*,'drhody_CSPH(i)',drhody_CSPH(i)
!         print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
!         print*,'sum_wab(i) ',sum_wab(i)
!         write(*,859)'ax(i) ',ax(i)
! c       write(*,859)'ay(i) '
!         write(*,859)'az(i) ',az(i)
! c        if(i_particleType(i).eq.3)then
! c          i_absolute = iabsolute_BP_Pointer_Index(i)
! c          i_num_FB = i_FB_Pointer_Info(i_absolute)
! c          print*,'i, i_absolute, i_num_FB ',i, i_absolute, i_num_FB
! c          print*,'Box_XC, Box_ZC         ',
! c     &            Box_XC(i_num_FB), Box_ZC(i_num_FB)
! c          print*,'bigU, bigW, bigOmegaY ',
! c     &            bigU(i_num_FB), bigW(i_num_FB), bigOmegaY(i_num_FB) 
! c          print*,'bigUdot, bigWdot ',
! c     &            bigUdot(i_num_FB), bigWdot(i_num_FB)
! c          print*,'OmegaYdot ',
! c     &            OmegaYdot(i_num_FB) 
! c          print*,'X_Friction, Z_Friction ',
! c     &            X_Friction(i_num_FB), X_Friction(i_num_FB)
! c          print*,'X_nonFriction, Z_nonFriction ',
! c     &            X_nonFriction(i_num_FB), X_nonFriction(i_num_FB)
! c          print*,'nb_inFriction ',
! c     &            nb_inFriction(i_num_FB) 
! c          print*,'Box_XC_old, Box_ZC_old   ',
! c     &            Box_XC_old(i_num_FB), Box_ZC_old(i_num_FB)
! c          print*,'bigU_old, bigW_old       ',
! c     &            bigU_old(i_num_FB), bigW_old(i_num_FB)
! c          print*,'xp(i)  , zp(i)  ',xp(i), zp(i)   
! c          print*,'up(i)  , wp(i)  ',up(i), wp(i)  
! c          print*,'ax(i)  , udot(i)',ax(i), udot(i)
! c          print*,'az(i)  , wdot(i)',az(i), wdot(i)
! c          print*,'xp_minus_R0(i), zp_minus_R0(i) ',
! c     &            xp_minus_R0(i), zp_minus_R0(i)
! c          print*,'- OmegaY*zp_minus_R0(i) ',
! c     &            - bigOmegaY(i_num_FB)*zp_minus_R0(i)
! c          print*,'  OmegaY*xp_minus_R0(i) ',
! c     &              bigOmegaY(i_num_FB)*xp_minus_R0(i)
! c        endif
! cc       !stop
!       end if
!       !---------------------

      call movingObjects(0)
      if(iBC.eq.1.and.iopt_FloatingBodies.eq.1)then   !Repulsive Force BC
        i_particleTypeChoice = 3   !Free-moving BPs
        call updateNormals_2D(nbfreem_local+1,nb_local,
     &                          i_particleTypeChoice)   
      end if

c
c  ...  corrector
c
       nb_image_local      = nb_local
       np_image_local      = np_local
       nbf_image_local     = nbf_local
       nbfm_image_local    = nbfm_local
       nbfreem_image_local = nbfreem_local
       nbp1_local  = nb_local + 1
       nfbp1_local = nbf_local + 1     
      
c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_2D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here nad not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(0)   !argument 1 selects densityFilter option


      call ac
      call correct

c      !-- Debug Code------
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'AFTER CORRECT, CORRECTOR, before movingOBJECTS'
c        print*,'rank_id, itime, dt ',rank_id, itime, dt
c        print*,'ddt_p, ddt_c, dt, dt2 ',ddt_p, ddt_c, dt, dt2
c        i = i_ParticleCheck  
c        print*,'i = ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
cc       print*,'ay(i), Volrhov(i) '       
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
cc       print*,'drhody_CSPH(i)',drhody_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
cc       write(*,859)'ay(i) '
c        write(*,859)'az(i) ',az(i)
c      endif

      !-- Perform final integration correction --
      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
         epsilon_Voldot = aVol(i)/pVol(i)
         pVol(i) = Volo(i)*
     &            (2.0 + epsilon_Voldot*dt)/(2.0 - epsilon_Voldot*dt)
         Volrho(i) = Volrhoo(i)*
     &     (2.0*Volrho(i) + ar(i)*dt)/(2.0*Volrho(i) - ar(i)*dt)
         rhop(i) = Volrho(i) / pVol(i)
      end do
      
      do ipcount=nb_local+1,np_local
        i = ip_index_FP_local(ipcount-nb_local)
         
        Volrhou(i)   = Volrhouo(i) + dt*ax(i)
c       Volrhov(i)   =
        Volrhow(i)   = Volrhowo(i) + dt*az(i)
         
        up(i) = Volrhou(i) / Volrho(i)
c       vp(i) =
        wp(i) = Volrhow(i) / Volrho(i)
      
        xp(i) = xo(i) + dt2*(uo(i) + up(i))
c       yp(i) =
        zp(i) = zo(i) + dt2*(wo(i) + wp(i))
         
      enddo

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
c  ...   Compute thermal energy
         VolTotalE(i) = VolTotalE(i) + dt2*aTE(i)
         TotalE(i) = VolTotalE(i) / pVol(i)
         TEp(i) = (TotalE(i)/rhop(i))
     &           - 0.5*(up(i)*up(i) + wp(i)*wp(i))
c  ...   compute pressure using the equation of state
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo
           
      call movingObjects(1)

      if (ivar_dt.eq.1) then
          call variable_time_step  
          ddt_c=dt_new
          dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
      endif

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*
c        print*,'In STEP_symplectic.f before INDEX_CHECK.f'
c        i =  i_ParticleCheck
c        print*,'itime, rank_id ',itime, rank_id
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'i, up, wp ',i,up(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*
c      end if
c      !stop
      
      
      call index_check_EastWest
      if(i_call_UpDown    .eq.1) call index_check_UpDown
c     if(i_call_NorthSouth.eq.1) call index_check_NorthSouth  !3-D only

c     Normals are calculated in subroutine updateNormals
      if(iBC.eq.1)then   !Repulsive Force BC
       i_particleTypeChoice = 0
       if(i_MPI_Adapt.eq.1)then
         nbf_uN_start = 1             !All BPs
       else
         nbf_uN_start = nbf_local+1   !All moving BPs
       endif
       call updateNormals_2D(nbf_uN_start,nb_local,i_particleTypeChoice)   
      end if

!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         print*
!         print*,'Accn Check, AFTER CORRECT, CORRECTOR'
!         print*,'rank_id, itime ',rank_id, itime
!         print*,'ddt_p, ddt_c, dt, dt2 ',ddt_p, ddt_c, dt, dt2
!         i = i_ParticleCheck  
!         print*,'i ',i
!         print*,'xp, zp  ',xp(i),zp(i)
!         print*,'up, wp  ',up(i),wp(i)
!         print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
!         print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
!         print*,'VolTotalE   , VolTotalEo ',
!      &          VolTotalE(i), VolTotalEo(i) 
!         print*,'aTE(i) ',aTE(i)
!         print*,'TEp, TotalE ',TEp(i),TotalE(i)
!         print*,'ar(i), aVol(i) ',ar(i), aVol(i)
!         print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
!         print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
!         print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
!         print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
!         print*,'dudx_CSPH(i)',dudx_CSPH(i)
!         print*,'dudz_CSPH(i)',dudz_CSPH(i)
!         print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
!         print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
!         print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
!         print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
!         print*,'sum_wab(i) ',sum_wab(i)
!         write(*,859)'ax(i) ',ax(i)
!         write(*,859)'az(i) ',az(i)
! c        if(i_particleType(i).eq.3)then
! c          i_absolute = iabsolute_BP_Pointer_Index(i)
! c          i_num_FB = i_FB_Pointer_Info(i_absolute)
! c          print*,'i, i_absolute, i_num_FB ',i, i_absolute, i_num_FB
! c          print*,'Box_XC, Box_ZC         ',
! c     &            Box_XC(i_num_FB), Box_ZC(i_num_FB)
! c          print*,'bigU, bigW, bigOmegaY ',
! c     &            bigU(i_num_FB), bigW(i_num_FB), bigOmegaY(i_num_FB) 
! c          print*,'bigUdot, bigWdot ',
! c     &            bigUdot(i_num_FB), bigWdot(i_num_FB)
! c          print*,'OmegaYdot ',
! c     &            OmegaYdot(i_num_FB) 
! c          print*,'X_Friction, Z_Friction ',
! c     &            X_Friction(i_num_FB), Z_Friction(i_num_FB)
! c          print*,'X_nonFriction, Z_nonFriction ',
! c     &            X_nonFriction(i_num_FB), Z_nonFriction(i_num_FB)
! c          print*,'nb_inFriction ',
! c     &            nb_inFriction(i_num_FB) 
! c          print*,'Box_XC_old, Box_ZC_old   ',
! c     &            Box_XC_old(i_num_FB), Box_ZC_old(i_num_FB)
! c          print*,'bigU_old, bigW_old       ',
! c     &            bigU_old(i_num_FB), bigW_old(i_num_FB)
! c          print*,'xp(i)  , zp(i)  ',xp(i), zp(i)   
! c          print*,'up(i)  , wp(i)  ',up(i), wp(i)  
! c          print*,'ax(i)  , udot(i)',ax(i), udot(i)
! c          print*,'az(i)  , wdot(i)',az(i), wdot(i)
! c          print*,'xp_minus_R0(i), zp_minus_R0(i) ',
! c     &            xp_minus_R0(i), zp_minus_R0(i)
! c          print*,'- OmegaY*zp_minus_R0(i) ',
! c     &            - bigOmegaY(i_num_FB)*zp_minus_R0(i)
! c          print*,'  OmegaY*xp_minus_R0(i) ',
! c     &              bigOmegaY(i_num_FB)*xp_minus_R0(i)
! c        endif
!         if(itime.eq.0)stop
! c        stop
!       end if
859     format(a11,' ',e24.16)        
      
      
      end
c